#! /usr/bin/env python

import os
import md5
from Cookie import SimpleCookie

# users set of roles
defaultUser = 'guest'
users = {
    defaultUser: {'password': '',
                  'roles'   : {
                      'map.control'     : False,
                      'map.edit'        : False,
                      'player.control'  : False,
                      'settings.control': False,
                      'sayall.control'  : False}},
    'admin'    : {'password': 'admin',
                  'roles'   : {
                      'map.control'     : True,
                      'map.edit'        : True,
                      'player.control'  : True,
                      'settings.control': True,
                      'sayall.control'  : True }},
    'member'   : {'password': 'member',
                  'roles'   : {
                      'map.control'     : True,
                      'map.edit'        : False,
                      'player.control'  : False,
                      'settings.control': False,
                      'sayall.control'  : True}}}

# http cookie
class Cookie:
    def __init__(self):
        self.user = defaultUser
        self.remember = False
        try:
            s = os.environ["HTTP_COOKIE"]
            if s.startswith('SID='):
                for uname in users:
                    m = md5.new(uname)
                    m.update(users[uname]['password'])
                    if s[4:] == m.hexdigest():
                        self.user = uname
                        break
        except KeyError:
            pass

    def login(self, uname, upassword = '', remember = False):
        if uname in users and users[uname]['password'] == upassword:
            self.user = uname
            self.remember = remember

    def loggedIn(self):
        return self.user != defaultUser

    def logout(self):
        self.user = defaultUser
        self.remember = False

    def role(self, key):
        return users[self.user]['roles'][key]

    def __str__(self):
        c = SimpleCookie()
        m = md5.new(self.user)
        m.update(users[self.user]['password'])
        c["SID"] = m.hexdigest()
        if self.remember:
            c["SID"]["max-age"] = 31536000 # Time to keep, in seconds, currently set to 1 year
            c["SID"]["expires"] = 31536000 # Obsolete, but netscape / explorer still seems to require it
        c["SID"]["version"] = 1
        return "%s" %c
