#! /usr/bin/env python

from bf2 import BF2Client
from index import webPage



# BF2 Special Forces xpack rcon client
class BF2SFClient(BF2Client):
    availMaps = [
        {'mapname': 'devils_perch'    , 'mapmodes': ['gpm_cq'], 'mapsizes': ['16', '32', '64']},
        {'mapname': 'ghost_town'      , 'mapmodes': ['gpm_cq'], 'mapsizes': ['16', '32', '64']},
        {'mapname': 'iron_gator'      , 'mapmodes': ['gpm_cq'], 'mapsizes': ['16', '32', '64']},
        {'mapname': 'leviathan'       , 'mapmodes': ['gpm_cq'], 'mapsizes': ['16', '32', '64']},
        {'mapname': 'mass_destruction', 'mapmodes': ['gpm_cq'], 'mapsizes': ['16', '32', '64']},
        {'mapname': 'night_flight'    , 'mapmodes': ['gpm_cq'], 'mapsizes': ['16', '32', '64']},
        {'mapname': 'surge'           , 'mapmodes': ['gpm_cq'], 'mapsizes': ['16', '32', '64']},
        {'mapname': 'warlord'         , 'mapmodes': ['gpm_cq'], 'mapsizes': ['16', '32', '64']}]

    # return map image location
    def getMapImage(self, map):
        return '/maps/bf2sf/%s.jpg' %map['mapname']

# BF2 Special Forces xpack web page
class BF2SFPage(webPage):
    images = webPage.images
    images['logo'] = '/images/bf2sf.gif'



if __name__ == '__main__':
    page = BF2SFPage(BF2SFClient(host='localhost', port=4711, password='Prutskip'))
    page.show()
    del page
