#! /usr/bin/env python

import os
import sys
import cgi
import cgitb; cgitb.enable() # enable exception handler to report via browser window

import auth



# version
version = '0.8.4'
# debug tracing flag
trace = False



# rcwt rcon client super class
class rconClient:
    # available maps
    availMaps = [
        {'mapname': 'unknown', 'mapmodes': ['?'], 'mapsizes': ['-']}]

    # retrieve map list
    def retrieveMaps(self):
        maps = []
        return maps

    # reload map list
    def reloadMaps(self):
        pass

    # save map list
    def saveMaps(self):
        pass

    # remove maps from map list
    def removeMaps(self, mapIDs):
        pass

    # move maps to top of map list
    def movetotopMaps(self, mapIDs):
        pass

    # append map to map list
    def appendMap(self, mapname, mapmode, mapsize):
        pass

    # return current map
    def currentMap(self):
        map = {'id': '?',
                'mapname': 'unknown',
                'mapmode': '?',
                'mapsize': '-'}
        return map

    # return next map
    def nextMap(self):
        map = {'id': '?',
                'mapname': 'unknown',
                'mapmode': '?',
                'mapsize': '-'}
        return map

    # restart current map
    def restartMap(self):
        pass

    # run next map
    def runNextMap(self):
        pass

    # set next map
    def setNextMap(self, id):
        pass

    # return map image location
    def getMapImage(self, map):
        return ''

    # retrieve player list
    def retrievePlayers(self):
        players = []
        return players

    # retrieve banned players
    def retrieveBannedPlayers(self):
        bannedPlayers = []
        return bannedPlayers

    # kick players
    def kickPlayers(self, playerIDs):
        pass

    # ban players
    def banPlayers(self, playerIDs, duration = 'round'):
        pass

    # unban players
    def unbanPlayers(self, playerIDs):
        pass

    # clear ban list
    def clearBanList(self):
        bannedPlayers = self.retrieveBannedPlayers()
        for player in bannedPlayers:
            self.unbanPlayers(player['id'])

    # retrieve server settings
    def retrieveSettings(self):
        settings = {}
        return settings

    # save server settings
    def saveSettings(self, settings):
        pass

    # send message to all players
    def sayAll(self, message):
        pass



# rcwt web page super class
class webPage:
    # style sheet
    styleSheet = '/default.css'

    # refresh page every xxx seconds
    refreshRate = 60

    # used colors
    colors = {
        'currentMap': '#6666CC',
        'nextMap'   : '#9999FF',
        'outMapList': 'black',
        'inMapList' : 'gray'}

    # used images
    images = {
        'logo'       : '',
        'next'       : '/images/next.gif',
        'restart'    : '/images/restart.gif',
        'runnext'    : '/images/play.gif',
        'reload'     : '/images/reload.gif',
        'save'       : '/images/save.gif',
        'refresh'    : '/images/refresh.gif',
        'stop'       : '/images/stop.gif'}

    def __init__(self, conn):
        self.conn = conn
        # retrieve script name
        self.script = os.path.basename(sys.argv[0])

    def __del__(self):
        del self.conn

    # show header
    def showHeader(self):
        print 'Content-type: text/html\n\n'
        print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'
        print '<html>'
        print '<head>'
        print '  <title>RCon Web Tool</title>'
        print '  <link type="text/css" rel="stylesheet" href="%s">' %self.styleSheet
        print '</head>'
        print '<body>'
        print '  <div id="header">'
        print '    <div class="midHeader">'
        print '      <table border="0" cellpadding="2" cellspacing="2">'
        print '        <tbody>'
        print '          <tr>'
        print '            <td><img border="0" alt="" src="%s"></td>' %self.images['logo']
        print '            <td><h1 class="headerTitle">RCon Web Tool</h1></td>'
        print '          </tr>'
        print '        </tbody>'
        print '      </table>'
        print '    </div>'
        print '    <div class="subHeader">'
        print '      <a href="?show=maps" title="show and change the map list">Maps</a>'
        print '      <a href="?show=players" title="show kick or ban players">Players</a>'
        print '      <a href="?show=settings" title="modify server settings">Settings</a>'
        print '      <a href="?show=sayall" title="sent message to all">Say all</a>'
        if not self.c.loggedIn():
            print '      <a href="?show=login" title="user login">Login</a>'
        else:
            print '      <a href="?logout=1" title="user logout">Logout %s</a>' %self.c.user
        print '    </div>'
        print '  </div>'

    # show footer
    def showFooter(self):
        print '<div id="footer">'
        print '  <div class="left">RCon Web Tool version %s written by Benaldi </div>' %version
        print '  <br class="doNotDisplay doNotPrint">'
        print '</div>'
        print '</body>'
        print '</html>'

    # show maps form
    def showMaps(self):
        # show current and next map info
        maps = self.conn.retrieveMaps()
        currentMap = self.conn.currentMap()
        nextMap    = self.conn.nextMap()
        print '  <h1>map info</h1>'
        print '  <table border="1" cellpadding="2" cellspacing="2">'
        print '    <tbody>'
        print '      <tr align="center">'
        print '        <td><b>current map</b></td>'
        print '        <td><b>next map</b></td>'
        print '      </tr>'
        print '      <tr align="center">'
        print '        <td><img title="current map" alt="current map" src="%s" align="middle"></td>' %self.conn.getMapImage(currentMap)
        print '        <td><img title="next map" alt="next map" src="%s" align="middle"></td>' %self.conn.getMapImage(nextMap)
        print '      </tr>'
        print '      <tr align="center">'
        print '        <td bgcolor="%s"><b>%s</b></td>' %(self.colors['currentMap'], currentMap['mapname'])
        print '        <td bgcolor="%s"><b>%s</b></td>' %(self.colors['nextMap'], nextMap['mapname'])
        print '      </tr>'
        if self.c.role('map.control'):
            print '      <tr align="center">'
            print '        <td><a href=%s?show=maps&restart=1><img alt="restart" src="%s" title="restart current map" border="0"></a></td>' %(self.script, self.images['restart'])
            print '        <td><a href=%s?show=maps&runnext=1><img alt="play next" src="%s" title="play next map" border="0"></a></td>' %(self.script, self.images['runnext'])
            print '      </tr>'
        print '    </tbody>'
        print '  </table>'

        # show map list
        print '  <table border="0" cellpadding="2" cellspacing="2">'
        print '    <tbody>'
        print '      <tr valign="top">'
        print '        <form method="get" action="%s?show=maps" name="maps">' %self.script
        print '          <td>'
        print '            <table border="1" cellpadding="2" cellspacing="2">'
        print '              <tbody>'
        print '                <tr>'
        print '                  <th colspan=5><b>map list</b></th>'
        print '                </tr>'
        print '                <tr>'
        if self.c.role('map.edit'):
            print '                  <th>-</th>'
        print '                  <th>name</th>'
        print '                  <th>mode</th>'
        print '                  <th>size</th>'
        if self.c.role('map.control'):
            print '                  <th>-</th>'
        print '                </tr>'
        for map in maps:
            if map['id'] == currentMap['id']: 
                print '                <tr bgcolor="%s">' %self.colors['currentMap']
            elif map['id'] == nextMap['id']:
                print '                <tr bgcolor="%s">' %self.colors['nextMap']
            else:
                print '                <tr>'
            if self.c.role('map.edit'):
                print '                  <td><input type="checkbox" name="map_%s"></td>' %map['id']
            print '                  <td>%s</td>' %map['mapname']
            print '                  <td>%s</td>' %map['mapmode']
            print '                  <td>%s</td>' %map['mapsize']
            if self.c.role('map.control'):
                if map['id'] == nextMap['id']:
                    print '                  <td>.</td>'
                else:
                    print '                  <td><a href=%s?show=maps&next=%s><img alt="set next" src="%s" title="set next map" border="0"></a></td>' %(self.script, map['id'], self.images['next'])
            print '                </tr>'
        print '              </tbody>'
        print '            </table>'
        if self.c.role('map.edit'):
            print '            <input type="submit" value="Remove" name="submit">'
            print '            <input type="submit" value="Move to top" name="submit">'
        print '          </td>'

        # show map form
        if self.c.role('map.edit'):
            print '          <td>'
            print '            <table border="1" cellpadding="2" cellspacing="2">'
            print '              <tbody>'
            print '                <tr>'
            print '                  <th colspan=5><b>available maps</b></th>'
            print '                </tr>'
            print '                <tr>'
            print '                  <th>-</th>'
            print '                  <th>name</th>'
            print '                  <th>mode</th>'
            print '                  <th>size</th>'
            print '                </tr>'

            for i in range(len(self.conn.availMaps)):
                availMap = self.conn.availMaps[i]
                color = self.colors['outMapList']
                for map in maps:
                    if availMap['mapname'] == map['mapname']: color = self.colors['inMapList']
                print '                <tr>'
                print '                  <td><input type="checkbox" name="addmap%i"></td>' %i
                print '                  <td><font color="%s">%s</font></td>' %(color, availMap['mapname'])
                print '                  <td><select name="mapmode%i">' %i
                for k in availMap['mapmodes']:
                    print '                    <option>%s</option>' %k
                print '                  </select></td>'
                print '                  <td><select name="mapsize%i">' %i
                for k in availMap['mapsizes']:
                    print '                    <option>%s</option>' %k
                print '                  </select></td>'
                print '                </tr>'
            print '              </tbody>'
            print '            </table>'
            print '            <input type="submit" value="Add" name="submit">'
            print '          </td>'
        print '        </form>'
        print '      </tr>'
        print '    </tbody>'
        print '  </table>'
        if self.c.role('map.edit'):
            print '  <br>'
            print '  <a href=%s?show=maps&reload=1><img alt="reload" src="%s" title="reload maplist" border="0"></a>' %(self.script, self.images['reload'])
            print '  <a href=%s?show=maps&save=1><img alt="save" src="%s" title="save maplist" border="0"></a>' %(self.script, self.images['save'])

        # auto page refresh
        query = cgi.parse()
        if query.has_key('refresh'):
            print '<meta http-equiv="refresh" content="%i">' %self.refreshRate
            print '<a href=%s?show=maps><img alt="stop" src="%s" title="stop refresh" border="0"></a>' %(self.script, self.images['stop'])
        else:
            print '<a href=%s?show=maps&refresh=1><img alt="refresh" src="%s" title="refresh page every %i seconds" border="0"></a>' %(self.script, self.images['refresh'], self.refreshRate)

    # show players form
    def showPlayers(self):
        # show current players
        players = self.conn.retrievePlayers()
        print '  <h1>player info</h1>'
        print '<form method="get" action="%s?show=players" name="players">' %self.script
        print '  <table border="1" cellpadding="2" cellspacing="2">'
        print '    <tbody>'
        print '      <tr>'
        print '        <th colspan=4><b>player information</b></th>'
        print '      </tr>'
        if len(players) > 0:
            print '      <tr>'
            if self.c.role('player.control'):
                print '        <th>-</th>'
            print '        <th>id</th>'
            print '        <th>name</th>'
            print '        <th>remote ip</th>'
            print '      </tr>'
            for player in players:
                print '      <tr>'
                if self.c.role('player.control'):
                    print '        <td><input type="checkbox" name="player_%s"></td>' %player['id']
                print '        <td>%s</td>' %player['id']
                print '        <td>%s</td>' %player['playername']
                print '        <td>%s</td>' %player['remoteip']
                print '      </tr>'
        else:
            print '      <tr>'
            print '        <td colspan=2 align="center">empty</td>'        
            print '      </tr>'
        print '    </tbody>'
        print '  </table>'
        if self.c.role('player.control'):
            print '  <input type="submit" value="Kick" name="submit">'
            print '  <input type="submit" value="Ban round" name="submit">'
            print '  <input type="submit" value="Ban perm" name="submit">'
        print '</form>'

        # show banned players
        bannedPlayers = self.conn.retrieveBannedPlayers()
        print '<form method="get" action="%s?show=players" name="bannedPlayers">' %self.script
        print '  <table border="1" cellpadding="2" cellspacing="2">'
        print '    <tbody>'
        print '      <tr>'
        print '        <th colspan=3><b>banned players</b></th>'
        print '      </tr>'
        if len(bannedPlayers) > 0:
            print '      <tr>'
            if self.c.role('player.control'):
                print '        <th>-</th>'
            print '        <th>playername</th>'
            print '        <th>duration</th>'
            print '      </tr>'
            for player in bannedPlayers:
                print '      <tr>'
                if self.c.role('player.control'):
                    print '        <td><input type="checkbox" name="banPlayer_%s"></td>' %player['id']
                print '        <td>%s</td>' %player['playername']
                print '        <td>%s</td>' %player['duration']
                print '      </tr>'
        else:
            print '      <tr>'
            print '        <td colspan=3 align="center">empty</td>'
            print '      </tr>'
        print '    </tbody>'
        print '  </table>'

        if self.c.role('player.control'):
            print '  <input type="submit" value="Clear" name="submit">'
            print '  <input type="submit" value="Clear all" name="submit">'
        print '</form>'

        # auto page refresh
        query = cgi.parse()
        if query.has_key('refresh'):
            print '<meta http-equiv="refresh" content="%i">' %self.refreshRate
            print '<a href=%s?show=players><img alt="stop" src="%s" title="stop refresh" border="0"></a>' %(self.script, self.images['stop'])
        else:
            print '<a href=%s?show=players&refresh=1><img alt="refresh" src="%s" title="refresh page every %i seconds" border="0"></a>' %(self.script, self.images['refresh'], self.refreshRate)

    # show server settings form
    def showSettings(self):
        print '  <h1>server settings</h1>'
        if self.c.role('settings.control'):
            print '  <form method="get" action="%s?show=settings" name="settings">' %self.script
            print '    <table border="1" cellpadding="2" cellspacing="2">'
            print '      <tbody>'
            print '        <tr>'
            print '          <th colspan=2><b>settings</b></th>'
            print '        </tr>'
            settings = self.conn.retrieveSettings()
            for key in settings:
                print '        <tr>'
                print '          <td>%s</td>' %key
                print '          <td><input name="%s" value="%s"></td>' %(key, settings[key])
                print '        </tr>'
            print '      </tbody>'
            print '    </table>'
            print '    <input type="submit" value="Save settings" name="submit">'
            print '  </form>'
        else:
            print '  <p>You have no rights to modify the server settings.</p>'

    # show say all form
    def showSayAll(self):
        print '  <h1>say all</h1>'
        if self.c.role('sayall.control'):
            print '  <form method="get" action="%s?show=sayall" name="sayall">' %self.script
            print '    <table border="0" cellpadding="2" cellspacing="2">'
            print '      <tbody>'
            print '        <tr>'
            print '          <td>Message:</td>'
            print '        </tr>'
            print '        <tr>'
            print '          <td><textarea name="sayalltext" rows="5" cols= "40"></textarea></td>'
            print '        </tr>'
            print '      </tbody>'
            print '    </table>'
            print '    <input type="submit" value="Say all" name="submit">'
            print '  </form>'
        else:
            print '  <p>You have no rights to sent a message</p>'

    # show login form
    def showLogin(self):
        print '  <h1>login</h1>'
        # redirect to map form not needed anymore???
        #if redirect:
        #        print '  <meta http-equiv="refresh" content="0;url=%s?show=maps"' %self.script
        print '  <form method="get" action="%s?show=login" name="login">' %self.script
        print '    <table border="0" cellpadding="2" cellspacing="2">'
        print '      <tbody>'
        print '        <tr>'
        print '          <td>Name:</td>'
        print '        </tr>'
        print '        <tr>'
        print '          <td><input type=text size=20 name="username"></td>'
        print '        </tr>'
        print '        <tr>'
        print '          <td>Password:</td>'
        print '        </tr>'
        print '        <tr>'
        print '          <td><input type=password size=20 name="userpassword"></td>'
        print '        </tr>'
        print '        <tr align="left">'
        print '          <td><input type="checkbox" name="userremember">remember me</td>'
        print '        </tr>'
        print '        <tr align="center">'
        print '          <td colspan=2><input type="submit" value="Login" name="submit"></td>'
        print '        </tr>'
        print '      </tbody>'
        print '    </table>'
        print '  </form>'

    def show(self):
        # parse form fields
        form = cgi.FieldStorage()
        if trace: print 'form: %s<br>' %form

        # parse query string
        query = cgi.parse()
        if trace: print 'query: %s<br>' %query

        # retrieve cookie session user with all coresponding roles
        self.c = auth.Cookie()
        if trace: print 'session: %s<br>' %self.c.user

        # check for login submit
        #redirect = False
        if form.has_key('submit') and form['submit'].value == 'Login':
            if form.has_key('username') and form.has_key('userpassword'):
                uname = form['username'].value
                upassword = form['userpassword'].value
                uremember = form.has_key('userremember') and form['userremember'].value == 'on'
                self.c.login(uname, upassword, uremember)
                print self.c # transfer cookie to client
                # redirect out of login page
                #redirect = True

        # check for logout query
        if query.has_key('logout'):
            self.c.logout()
            print self.c # transfer cookie to client

        # show header
        self.showHeader()
        c = auth.Cookie()

        # check for remove map submit
        if form.has_key('submit') and form['submit'].value == 'Remove':
            mapIDs = []
            for key in form.keys():
                if key.startswith('map_') and form[key].value == 'on':
                    mapIDs.append(key[4:])
            result = self.conn.removeMaps(mapIDs)
            if trace: print 'removeMaps: %s<br>' %result

        # check for move to top submit
        if form.has_key('submit') and form['submit'].value == 'Move to top':
            mapIDs = []
            for key in form.keys():
                if key.startswith('map_') and form[key].value == 'on':
                    mapIDs.append(key[4:])
            result = self.conn.movetotopMaps(mapIDs)
            if trace: print 'movetotopMaps: %s<br>' %result

        # check for add map submit
        if form.has_key('submit') and form['submit'].value == 'Add':
            for i in range(len(self.conn.availMaps)):
                if form.has_key('addmap%i' %i) and form['addmap%i' %i].value == 'on':
                    result = self.conn.appendMap(self.conn.availMaps[i]['mapname'], form['mapmode%i' %i].value, form['mapsize%i' %i].value)
                    if trace: print 'addMap: %s<br>' %result

        # check for player kick submit
        if form.has_key('submit') and form['submit'].value == 'Kick':
            playerIDs = []
            for key in form.keys():
                if key.startswith('player_') and form[key].value == 'on':
                    playerIDs.append(key[7:])
            result = self.conn.kickPlayers(playerIDs)
            if trace: print 'kickPlayers: %s<br>' %result

        # check for player ban round submit
        if form.has_key('submit') and form['submit'].value == 'Ban round':
            playerIDs = []
            for key in form.keys():
                if key.startswith('player_') and form[key].value == 'on':
                    playerIDs.append(key[7:])
            result = self.conn.banPlayers(playerIDs)
            if trace: print 'banPlayers: %s<br>' %result

        # check for player ban permanent submit
        if form.has_key('submit') and form['submit'].value == 'Ban perm':
            playerIDs = []
            for key in form.keys():
                if key.startswith('player_') and form[key].value == 'on':
                    playerIDs.append(key[7:])
            result = self.conn.banPlayers(playerIDs, 'perm')
            if trace: print 'banPlayers: %s<br>' %result

        # check for player clear submit
        if form.has_key('submit') and form['submit'].value == 'Clear':
            playerIDs = []
            for key in form.keys():
                if key.startswith('banPlayer_') and form[key].value == 'on':
                    playerIDs.append(key[10:])
            result = self.conn.unbanPlayers(playerIDs)
            if trace: print 'unbanPlayers: %s<br>' %result

        # check for player clear all submit
        if form.has_key('submit') and form['submit'].value == 'Clear all':
            result = self.conn.clearBanList()
            if trace: print 'clearBanList: %s' %result

        # check for save settings submit
        if form.has_key('submit') and form['submit'].value == 'Save settings':
            settings = self.conn.retrieveSettings()
            for key in settings:
                settings[key] = form[key].value
            result = self.conn.saveSettings(settings)
            if trace: print 'Settings: %s<br>' %result

        # check for say all submit
        if form.has_key('submit') and form['submit'].value == 'Say all':
            if form.has_key('sayalltext'):
                lines = form['sayalltext'].value
                lines = lines.split('\r\n')
                for line in lines:
                    result = self.conn.sayAll(line)
                    if trace: print 'sayAll: %s<br>' %result

        # check for maps queries
        if query.has_key('next'):
            result = self.conn.setNextMap(query['next'][0])
            if trace: print 'nextLevel: %s<br>' %result
        if query.has_key('runnext'):
            result = self.conn.runNextMap()
            if trace: print 'nextMap: %s<br>' %result
        if query.has_key('restart'):
            result = self.conn.restartMap()
            if trace: print 'restartMap: %s<br>' %result
        if query.has_key('reload'):
            result = self.conn.reloadMaps()
            if trace: print 'loadMaplist: %s<br>' %result
        if query.has_key('save'):
            result = self.conn.saveMaps()
            if trace: print 'saveMaplist: %s<br>' %result

        # show main-copy
        print '<div id="main-copy">'
        if query.has_key('show') and query['show'][0] == 'players':
            self.showPlayers()
        elif query.has_key('show') and query['show'][0] == 'settings':
            self.showSettings()
        elif query.has_key('show') and query['show'][0] == 'sayall':
            self.showSayAll()
        elif query.has_key('show') and query['show'][0] == 'login':
            self.showLogin()
        else: # show default maps form
            self.showMaps()
        print '</div>'
        self.showFooter()


"""def showError(self):
    self.showHeader()

    # show main-copy
    print '<div id="main-copy">'
    print '  <font color="red"><h2>ERROR<br><br>'
    print '  Connection to the server is lost.<br>'
    print '  Check if your server is correct configured and running.</h2></font>'
    print '</div>'

    self.showFooter()"""
